﻿local GarrisonDone = ...

local DEBUG = false;

if (not GarrisonDone_Varsb) then GarrisonDone_Varsb = {} end

if (not GarrisonDoneBuildFrame) then GarrisonDoneBuildFrame = GarrisonDoneBuildFrame end


local character = UnitName("player").."-"..GetRealmName();


function GarrisonDone_BuildOnLoad()
        GarrisonDoneBuildFrame:RegisterEvent("GARRISON_LANDINGPAGE_SHIPMENTS");
        GarrisonDoneBuildFrame:RegisterEvent("GARRISON_SHIPMENT_RECEIVED");
        GarrisonDoneBuildFrame:RegisterEvent("SHIPMENT_CRAFTER_OPENED");
        GarrisonDoneBuildFrame:RegisterEvent("SHIPMENT_CRAFTER_CLOSED");
end
   
            
function GarrisonDone_Buildings(self, event, ...)
        if ( event == "GARRISON_LANDINGPAGE_SHIPMENTS" ) then
            GarrisonDone_GetShipments(self);
            GarrisonDone_UpdateShipData(data);
            GarrisonDoneBuildFrame_OnUpdate(self, elapsed);
        elseif ( event == "GARRISON_SHIPMENTS" ) then
            GarrisonDone_GetShipments(self);
            GarrisonDone_UpdateShipData(data);
            GarrisonDoneBuildFrame_OnUpdate(self, elapsed);
        elseif ( event == "GARRISON_SHIPMENT_RECEIVED" ) then
            C_Garrison.RequestLandingPageShipmentInfo();
        elseif (event == "SHIPMENT_CRAFTER_OPENED") then
            GarrisonDone_GetShipments(self);
            GarrisonDone_UpdateShipData(data);
            GarrisonDoneBuildFrame_OnUpdate(self, elapsed);
        elseif (event == "SHIPMENT_CRAFTER_CLOSED") then
            GarrisonDone_GetShipments(self);
            GarrisonDone_UpdateShipData(data);
            GarrisonDoneBuildFrame_OnUpdate(self, elapsed);
            C_Garrison.RequestLandingPageShipmentInfo();
    end
end


function GarrisonDoneBuildScrollFrame_OnShow(self)
        if GarrisonDoneBuildScrollFrame:IsShown() then
        C_Garrison.RequestLandingPageShipmentInfo();
        GarrisonDone_GetShipments(self);
        GarrisonDoneBuildFrame_OnUpdate(self, elapsed);
        C_Garrison.RequestLandingPageShipmentInfo();
    end
end

        -- use a different system for seconds than Alts use, so no conflict, maybe ddumb idea and use same?? --
function GarrisonDone_SecondsToStrTime(seconds)
	local originalSeconds = seconds;
	-- Seconds In Min, Hour, Day
    local secondsMinute = 60;
    local secondsHour  = 60 * secondsInAMinute;
    local secondsDay    = 24 * secondsInAnHour;
    -- Days
    local days = math.floor( seconds / secondsDay );
    -- Hours
    local hourSeconds = seconds % secondsDay;
    local hours = math.floor( hourSeconds / secondsHour );
    -- Minutes
    local minuteSeconds = hourSeconds % secondsHour;
    local minutes = floor( minuteSeconds / secondsMinute );
    -- Seconds
    local remainingSeconds = minuteSeconds % secondsMinute;
    local seconds = math.ceil( remainingSeconds );
	--
	local strTime = (days > 0 and hours == 0 and days .. " day") or (days > 0 and days .. " day " .. hours .. " hr") or (hours > 0 and minutes == 0 and hours .. " hr") or (hours > 0 and hours .. " hr " .. minutes .. " min") or (minutes > 0 and minutes .. " min") or seconds .. " sec";
end

        -- convert the str back to seconds so we can count --
function GarrisonDone_StrTimeToSeconds(str)
	if not str then return 0; end
	local M = function( i )
		if i == "hr" then
			return 3600;
		elseif i == "min" then
			return 60;
		elseif i == "sec" then
			return 1;
		end
	end
	local t1, i1, t2, i2 = strsplit( " ", str ); -- x hr y min or x hr or x min or x sec --
	return t1 * M( i1 ) + ( t2 and t2 * M( i2 ) or 0 );
end



        -- Set Buldings and Shipment Data, ?? why isnt this updating each time --
function GarrisonDone_UpdateShipData(data)
        GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")] = {};
	    for _, building, v in ipairs(C_Garrison.GetBuildings()) do
        local buildingID, buildingName, _, _, _, rank, _, _, _, _, _, _, _, _, _, _, hasFollowerSlot, _, _, _, isBeingBuilt, _, _, _, _ = C_Garrison.GetOwnedBuildingInfo(building.plotID);
		local fname, _, _, _, _, _, _, _ = C_Garrison.GetFollowerInfoForBuilding(building.plotID);
		local name, _, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString, itemName, _, _, _ = C_Garrison.GetLandingPageShipmentInfo(buildingID);
        if shipmentCapacity then
			table.insert(GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")],
            { 
            ["buildingID"] = buildingID,
            ["idName"] = buildingName,
                ["bname"] = name,
                ["fname"] = fname,
                ["item"] = itemName,
				["capacity"] = shipmentCapacity,
				["ready"] = tonumber(shipmentsReady),
				["total"] = tonumber(shipmentsTotal),
                ["creationTime"] = creationTime,
				["duration"] = duration,
                ["timeLeft"] = timeleftString,
				["lastUpdate"] = time(),
                ["inprog"] = 0,
                ["toSeconds"] = GarrisonDone_StrTimeToSeconds(timeleftString),
                ["class"] = UnitClass("player"),
                ["character"] = GetUnitName("player"),
                ["realm"] = GetRealmName()
			});
        if DEBUG == true then
            DEFAULT_CHAT_FRAME:AddMessage("Shipments Updated Sir") -- debug
            end
        end
    end
    GarrisonDone_GetShipments(self);
end
 
 
 
        -- set locals for scroll frame --
local maxsBars = 8
local barsList = {}
local unUsedsBars = {}
local totalsBars = 0
local tempSortedList = {}
local sortsOrders = {
		{name = "Default", value = "default"},
        }
    
        -- rotate the bar frames so we dont waste resources --
function GarrisonDone_ShipRebuild(self)
	local template = "GarrisonDones_"..GetRealmName().."_"..GetUnitName("player").."_"
	for index, object in pairs(barsList) do
		if string.find("GarrisonDones_"..GetRealmName().."_"..GetUnitName("player").."_", index) then
			unUsedsBars[#unUsedsBars + 1] = object
			object.bars:Hide()
			barsList[index] = nil
		end
	end
	GarrisonDone_Varsb[GetRealmName()][GetUnitName("player")] = {}
end
 
        -- Update Shipments using Garrison Landing Page code --
function GarrisonDone_GetShipments(self)
  local shipmentIndex = 1;
  local buildings = C_Garrison.GetBuildings();
  for i = 1, #buildings do
    local buildingID = buildings[i].buildingID;
    if ( buildingID) then
      local name, texture, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString, itemName, itemIcon, itemQuality, itemID = C_Garrison.GetLandingPageShipmentInfo(buildingID);
        if ( not shipment ) then
            return;
        end
        if ( name and shipmentCapacity > 0 ) then
            shipment.buildingID = buildingID;
            shipment.plotID = buildings[i].plotID;
        if (shipmentsTotal) then
            if ( shipmentsReady == shipmentsTotal ) then
                DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20MGD "..buildingID.." Has Completed ALL Shipments")   
                    end
                end
            end
        end
    end
        for i = shipmentIndex, #self.Shipments do
        self.Shipments[i]:Hide();
    end
    if DEBUG == true then
        DEFAULT_CHAT_FRAME:AddMessage("Shipments Updated Here to Sir") -- debug
    end
end
 
 
        -- Load the Bars that will make up the list --
function GarrisonDoneBuildFrame_OnLoad(self)
	for l = 1, maxsBars, 1 do
		    bars = CreateFrame("StatusBar", "GarrisonDones_bars_"..l, GarrisonDoneBuildScrollFrame)
		    bars:SetWidth(300)
		    bars:SetHeight(19)
		    bars:SetOrientation("HORIZONTAL")
            local backdrop = {
                bgFile = "Interface\AddOns\GarrisonDone\images\StatusBar7",  
            --    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
            --    tile = false,
                edgeSize = 1,
                insets = {
                    left = 1,
                    right = 1,
                    top = 1,
                    bottom = 1
                }
            }
            bars:SetBackdrop(backdrop)
            bars:Raise()
            bars:SetBackdropColor(.0, .0, .0, 0.9)
		    MGDbLabel = bars:CreateFontString("GarrisonDones_labels_"..l, "ARTWORK", "GameFontNormalMed2")
		    MGDbLabel:SetTextHeight(12)
		    MGDbLabel:SetTextColor(230, 204, 128, 10)
		    MGDbLabel:SetPoint("LEFT", 0, 0, bars)
		    MGDbLabel:SetPoint("RIGHT", bars)
		    MGDbLabel:SetJustifyH("LEFT")
		    MGDbLabel:SetNonSpaceWrap(false)
		    bars:SetPoint("TOPLEFT", "GarrisonDoneBuildScrollFrame", 10, 20-22*(l))
		    bars:SetPoint("RIGHT", "GarrisonDoneBuildScrollFrame", 0, 0)
	end
end

-- C_Timer.After(40, function() GarrisonDone_Buildings() end)


-- We have the Data now update the frame to show it - can we add a blank frame between names ?? --
function GarrisonDoneBuildFrame_OnUpdate(self, elapsed)
            if GarrisonDoneBuildFrame:IsShown() == true then
                C_Garrison.RequestLandingPageShipmentInfo();
                GarrisonDone_GetShipments(self);
                GarrisonDoneBuildPageName:SetText("Buildings & Shipments");
			    local l = 0
			    local d = 0
                if GarrisonDone_Varsb then
					for realm, v1 in pairs(GarrisonDone_Varsb) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								l = l + 1
								local offset = FauxScrollFrame_GetOffset(GarrisonDoneBuildScrollFrame)
								if l > offset and l <= (offset + maxsBars) then
									d = d + 1
                                    local bname = data.bname
									local buildingID = data.buildingID
									local bars, texture, label, MGDbLabel, MGDbLabel1, object
									bars = _G["GarrisonDones_bars_"..d]
									MGDbLabel = _G["GarrisonDones_labels_"..d]
                                    
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    MGDbLabel:SetPoint("LEFT", 10, 0, bars)
                                    if data.class == "Death Knight" then color = "|cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffABD473"
                                    elseif data.class == "Mage" then color = "|cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffC79C6E"
                                    end
                                    
                                        
                                        -- Shorten the Mines for Alliance --
                                    if data.idName == "Lunarfall Excavation" then data.idName = "Excavation" end
                                        -- Shorten the Shipyard for Alliance --
                                    if data.idName == "Lunarfall Shipyard" then data.idName = "Shipyard" end
                                        -- Shorten the Gnomish Gearworks for Alliance --
                                    if data.idName == "Gnomish Gearworks" then data.idName = "Gearworks" end
                                        -- Shorten the Goblin Workshop for Horde --
                                    if data.idName == "Goblin Workshop" then data.idName = "Workshop" end
                                        -- Give Ready and Total a number in case there are none in progress --
                                    if data.ready == nil then data.ready = 0 end
                                    if data.total == nil then data.total = 0 end
                                        -- Count down In progress --
                                    local inprog = (data.total - data.ready)
                                        -- Is followers Assigned, Y/N --
                                --    if data.fname == nil then data.fname = "|cffff0000N" 
                                --    elseif data.fname ~= "|cffff0000N" then data.fname = "Y" end
                                        -- adjust time left ii = 0 --
                                    if data.timeLeft == nil then data.timeLeft = "None" end
                                        -- Give Creation and time to seconds a number in case it = nil --
                                    if data.creationTime == nil then data.creationTime = 0 end
                                    if data.toSeconds == nil then data.toSeconds = 0 end
                                        --  Set timer to count down till next shipment, should reset till total = 0 --
                                    if data.duration == nil then data.duration = 0 end
                                    local ta = data.creationTime -- time we started this group of shipments --
                                    local tb = data.duration * inprog -- total time till finish, for LDB as Big enough frame --
                                    local tc = ta + tb  -- Actual finish time, for LDB as Big enough frame, but you never know -- 
                                    local td = 14400 -- duration fixed time on all Follower Buildings --
                                    local te = data.toSeconds -- time till 1st shipment ready, needs to reset after each shipment --
                                    local tf = data.creationTime + (data.ready * data.duration)  -- As shipments complete add duration to creation time --
                                    local tg = tc - tf -- Actual finish time minus Shipments ready --
                                    
                                    if te <= 0 and inprog > 0 then
                                    data.toSeconds = 14395
                                    elseif inprog <= 0 then
                                    data.toSeconds = 0
                                    end 
                                    local te = data.toSeconds;
                                   
      
      
                                        -- Set Labels --
                                    if data.total > 0 then
                                    if te >= 0 then 
									bars:SetValue(floor(te))
									MGDbLabel:SetText(string.format("%s: %02d:%02d", color..character.."-"..realm:sub(1,4)..":|r |cffE6CC80"..data.idName:sub(1,10).."|r:  |cff1eff00"..data.ready.."|cffffffff-|cfffeef02"..inprog.."|cffffffff-|cffe6cc80"..data.capacity.." - |cff00FAF6", floor(te/3600), floor(mod(te,3600)/60)))
                                        end
                                    else
                                    if data.total == 0 then
									MGDbLabel:SetText(string.format(color..character.."-"..realm:sub(1,4)..":|r |cffE6CC80"..data.idName:sub(1,20).."|r:|cffFFFC00 Out to Lunch"))
                                    -- show the Bars --
									bars:Show()
                                        end
                                    end
                                end								
							end 
						end
					end  
			    FauxScrollFrame_Update(GarrisonDoneBuildScrollFrame, l, maxsBars, 15)
			    if d <= maxsBars then
				    d = d + 1
				for j = d, maxsBars do
					_G["GarrisonDones_bars_"..j]:Hide()
				    end
			    end
		    end
            if GarrisonDoneBuildFrame:IsShown() == true then
		        GarrisonDoneBuildScrollFrame:Show()
	        else
		        GarrisonDoneBuildFrame:Hide()
                GarrisonDoneBuildScrollFrame:Hide()
        end
    end
        if DEBUG == true then
        DEFAULT_CHAT_FRAME:AddMessage("All Buldings Updated Sir") -- debug
        return
     end
end

        -- old Update the Scroll Bar --
function GarrisonDoneBuildFrame_ScrollBar_Update()
	        
end
 

function GarrisonDoneBuildSort_OnLoad()
	        for l = 1, #sortsOrders do
		    info = {
			    text = sortsOrders[l].name;
			    value = sortsOrders[l].value;
		    }
	end
end 

function GarrisonDoneBuild_OnClose()
        GarrisonDoneBuildFrame:UnregisterEvent("GARRISON_LANDINGPAGE_SHIPMENTS");
        GarrisonDoneBuildFrame:UnregisterEvent("GARRISON_SHIPMENT_RECEIVED");
        GarrisonDoneBuildFrame:UnregisterEvent("SHIPMENT_CRAFTER_OPENED");
        GarrisonDoneBuildFrame:UnregisterEvent("SHIPMENT_CRAFTER_CLOSED");
end

 
 